# Load database - Stress testing

This folder contains stress testing script which generates fake reports for Rudder node, by inserting directly in the database, to load the compliance part of Rudder and measure performance.

## Dependencies
* psycopg2

## Compatibility

Script load-database.py is compatible with Rudder 4.x. It will generate exact reports for all accepted node, by reading content of table nodesconfigurations. It can also optionnaly generates Error and Repairs logs

Script load-database-3.x.py is compatible with Rudder 3.x. It works in a degraded mode, as it simply copies all reports from Rudder root server to the nodes, with correct NodeConfigId - so unless all the nodes have exactly the same configuration as the Rudder server root, there will be a lot of Missing and Unexpected reports

## Configuration

Prior to using the script, you need to configure the PostgreSQL connectivity at the beginning of the script

You may also want to configure the proportion of error and repaired reports generated by modifying variables repair_proportion and error_proportion


## Usage
* Generate reports for all the accepted nodes within Rudder 4.1
```
load-database.py
```

* To generate reports from outdated expected reports, you'll need to init (only once) the table to store the outdated configs ids with
```
load-database.py init_table
```
and then store node config ids in this tables. To store (or update) them, you'll need to define a mandatory filter on node ids with a regular expression, like
```
load-database.py store_config_id '^[b|c].*[a]$'
```
to store current node config ids from all nodes starting with 'b' or 'c', and ending by 'a'

Then you can generate reports using there stored node config ids with
```
load_database.py use_config_id
```


